package com.fr.plugin.decision.integration;

import com.fr.decision.fun.impl.AbstractControllerRegisterProvider;
import com.fr.plugin.context.PluginContexts;
import com.fr.plugin.decision.integration.controller.IntegratedController;
import com.fr.plugin.decision.integration.service.IntegrateAuthService;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.stable.fun.Authorize;

@Authorize(callSignKey = "com.fr.plugin.decision.integration")
@FunctionRecorder
public class ControllerBridgeImpl extends AbstractControllerRegisterProvider {
    @ExecuteFunctionRecord
    @Override
    public Class<?>[] getControllers() {
        if (PluginContexts.currentContext().isAvailable()) {
            return new Class[]{IntegratedController.class};
        } else {
            return new Class[0];
        }
    }
}
