package com.fr.plugin.decision.integration.config.strategy;

import com.fr.general.ComparatorUtils;
import com.fr.third.fasterxml.jackson.annotation.JsonCreator;
import com.fr.third.fasterxml.jackson.annotation.JsonValue;

/**
 * @Author JianYe.Wang
 * @Data 10:14
 * @Description TODO
 * @Version 10.0
 **/

/**
 * "department": {
 * "name": "beijing",
 * "id": "02"
 * }
 */
public enum CreateDepartmentStrategy {
    /**
     * 根据id长度， 01 011 012
     */
    DEP_ID_LENGTH(0),
    /**
     * 根据name拼接 中国|北京市|朝阳区
     */
    DEP_NAME_GROUP(1);

    private int type;

    CreateDepartmentStrategy(int type) {
        this.type = type;
    }

    @JsonValue
    public int toInteger() {
        return this.type;
    }

    @JsonCreator
    public static CreateDepartmentStrategy parse(int value) {
        for (CreateDepartmentStrategy type : CreateDepartmentStrategy.values()) {
            if (ComparatorUtils.equals(value, type.toInteger())) {
                return type;
            }
        }
        return null;
    }
}
