package com.fr.plugin.decision.integration.config.strategy;

import com.fr.general.ComparatorUtils;
import com.fr.third.fasterxml.jackson.annotation.JsonCreator;
import com.fr.third.fasterxml.jackson.annotation.JsonValue;

/**
 * @Author JianYe.Wang
 * @Data 21-06-07 10:07
 * @Description TODO
 * @Version 10.0
 **/
public enum CreatePwdStrategy {
    SAME_USER(0), RANDOM(1);

    private int type;

    CreatePwdStrategy(int type) {
        this.type = type;
    }

    @JsonValue
    public int toInteger() {
        return this.type;
    }

    @JsonCreator
    public static CreatePwdStrategy parse(int value) {
        for (CreatePwdStrategy type : CreatePwdStrategy.values()) {
            if (ComparatorUtils.equals(value, type.toInteger())) {
                return type;
            }
        }

        return null;
    }
}
