package com.fr.plugin.decision.integration.config.strategy.user;

import com.fr.config.Identifier;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.config.utils.UniqueKey;
import com.fr.plugin.decision.integration.config.strategy.CreatePwdStrategy;
import com.fr.plugin.decision.integration.config.strategy.user.impl.ContainDepRoleStrategy;
import com.fr.plugin.decision.integration.config.strategy.user.impl.OnlyUserStrategy;
import com.fr.third.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;
import com.fr.third.fasterxml.jackson.annotation.JsonTypeInfo;

/**
 * @Author JianYe.Wang
 * @Data 21-6-7 10:01
 * @Description TODO
 * @Version 10.0
 **/
@JsonIgnoreProperties({"id", "data", "classInfo", "nameSpace"})
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "userType")
@JsonSubTypes({
        @JsonSubTypes.Type(value = OnlyUserStrategy.class, name = "onlyUser"),
        @JsonSubTypes.Type(value = ContainDepRoleStrategy.class, name = "containDepRole")
})
public abstract class CreateUserStrategy extends UniqueKey {

    @Identifier("pwdStrategy")
    private Conf<CreatePwdStrategy> pwdStrategy = Holders.simple(CreatePwdStrategy.SAME_USER);

    public CreatePwdStrategy getPwdStrategy() {
        return pwdStrategy.get();
    }

    public void setPwdStrategy(CreatePwdStrategy pwdStrategy) {
        this.pwdStrategy.set(pwdStrategy);
    }
}
