package com.fr.plugin.decision.integration.config.strategy.user.impl;

import com.fr.config.Identifier;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.plugin.decision.integration.config.strategy.CreateDepartmentStrategy;
import com.fr.plugin.decision.integration.config.strategy.user.CreateUserStrategy;
import com.fr.stable.StringUtils;
import com.fr.third.fasterxml.jackson.annotation.JsonTypeName;

/**
 * @Author JianYe.Wang
 * @Data 10:13
 * @Description TODO
 * @Version 10.0
 **/
@JsonTypeName("containDepRole")
public class ContainDepRoleStrategy extends CreateUserStrategy {

    @Identifier("depStrategy")
    private Conf<CreateDepartmentStrategy> depStrategy = Holders.simple(CreateDepartmentStrategy.DEP_ID_LENGTH);

    @Identifier("specialRootId")
    private Conf<String> specialRootId = Holders.simple(StringUtils.EMPTY);

    // 分隔符， CreateDepEnum.DEP_NAME_GROUP 会用到
    @Identifier("separator")
    private Conf<String> separator = Holders.simple(StringUtils.EMPTY);

    public CreateDepartmentStrategy getDepStrategy() {
        return depStrategy.get();
    }

    public void setDepStrategy(CreateDepartmentStrategy depStrategy) {
        this.depStrategy.set(depStrategy);
    }

    public String getSpecialRootId() {
        return specialRootId.get();
    }

    public void setSpecialRootId(String specialRootId) {
        this.specialRootId.set(specialRootId);
    }

    public String getSeparator() {
        return separator.get();
    }

    public void setSeparator(String separator) {
        this.separator.set(separator);
    }
}
