/*
package com.fr.plugin.decision.integration.filter;

import com.fr.data.NetworkHelper;
import com.fr.decision.fun.impl.AbstractEmbedRequestFilterProvider;
import com.fr.decision.mobile.terminal.TerminalHandler;
import com.fr.decision.webservice.utils.DecisionServiceConstants;
import com.fr.decision.webservice.utils.WebServiceUtils;
import com.fr.decision.webservice.v10.login.LoginService;
import com.fr.decision.webservice.v10.login.TokenResource;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.integration.config.IntegrateConf;
import com.fr.plugin.decision.integration.utils.CommonUtils;
import com.fr.stable.StringUtils;
import com.fr.stable.web.Device;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

*/
/**
 * @CreateBy JianYe
 * @Date 2023/6/30 9:37
 **//*

public class IgnoreMobileCookieFilter extends AbstractEmbedRequestFilterProvider {

    @Override
    public void doFilter(HttpServletRequest req, HttpServletResponse res, FilterChain filterChain) throws IOException, ServletException {

        try {
            if (accept(req)) {
                HttpServletRequest wrapper = new IgnoreCookieHttpRequestWrapper(req);
                filterChain.doFilter(wrapper, res);
                return;
            }
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e, e.getMessage());
        }

        filterChain.doFilter(req, res);
    }

    private boolean accept(HttpServletRequest request) {

        if (!IntegrateConf.getInstance().getIgnoreMobileCookie() ||!CommonUtils.isMobile(request)) {
            return false;
        }

        String cookieToken = TokenResource.COOKIE.getToken(request);
        String queryToken = request.getParameter(DecisionServiceConstants.FINE_AUTH_TOKEN_NAME);

        return StringUtils.isNotBlank(queryToken) && StringUtils.isNotBlank(cookieToken) && !loginStatusValid(request, cookieToken) && loginStatusValid(request, queryToken);

    }

    private boolean loginStatusValid(HttpServletRequest request, String token) {
        Device device = NetworkHelper.getDevice(request);
        try {
            LoginService.getInstance().loginStatusValid(token, TerminalHandler.getTerminal(request, device), WebServiceUtils.getIpInfoFromRequest(request));
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    private class IgnoreCookieHttpRequestWrapper extends HttpServletRequestWrapper{

        public IgnoreCookieHttpRequestWrapper(HttpServletRequest request) {
            super(request);
        }

        @Override
        public Cookie[] getCookies() {
            HttpServletRequest request = (HttpServletRequest) getRequest();
            Cookie[] cookies = request.getCookies();
            List<Cookie> cookieList = new ArrayList<>(Arrays.asList(cookies));
            for (Cookie cookie : cookieList) {
                if (StringUtils.equals(cookie.getName(), DecisionServiceConstants.FINE_AUTH_TOKEN_NAME)) {
                    cookieList.remove(cookie);
                    cookie.setValue(request.getParameter(cookie.getName()));
                    cookieList.add(cookie);
                    FineLoggerFactory.getLogger().info("Token replace successful!");
                    break;
                }
            }
            return cookieList.toArray(new Cookie[0]);
        }
    }

}
*/
