package com.fr.plugin.decision.integration.service;

import com.fr.base.FRContext;
import com.fr.base.TemplateUtils;
import com.fr.data.NetworkHelper;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.file.filetree.FileNode;
import com.fr.file.filetree.FileNodes;
import com.fr.json.JSONException;
import com.fr.plugin.decision.integration.bean.TplInfoBean;
import com.fr.report.DesignAuthority;
import com.fr.workspace.WorkContext;
import com.fr.workspace.Workspace;
import com.fr.workspace.server.authority.AuthorityOperator;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;

@Deprecated
public class IntegrateCustomService {

    private static final String FRM_PATH = "/view/form?viewlet=";
    private static final String CPT_PATH = "/view/report?viewlet=";

    private volatile static IntegrateCustomService service = null;

    public IntegrateCustomService() {
    }

    public static IntegrateCustomService getInstance() {
        if (service == null) {
            synchronized (IntegrateAuthService.class) {
                if (service == null) {
                    service = new IntegrateCustomService();
                }
            }
        }
        return service;
    }

    public String generateDefaultHomePageUrl(HttpServletRequest request) throws Exception {
        String originalURL = NetworkHelper.getOriginalURL(request);
        String requestURI = request.getRequestURI();
        return TemplateUtils.render(originalURL.replace(requestURI, "${fineServletURL}"));
    }

    public ArrayList getRemoteTplListByUserId(String userId, String servletName) {
        Workspace workspace = WorkContext.getCurrent();
        FileNodes root = FRContext.getFileNodes();
        ArrayList fileNodes = new ArrayList();

        fileNodes.add(getNodeItem("reportlets", "", true, servletName));
        if (UserService.getInstance().isAdmin(userId)) {
            getFileNode(fileNodes, root, "reportlets", servletName);
        } else {
            DesignAuthority auth = (workspace.get(AuthorityOperator.class)).getAuthorities(userId)[0];
            for (DesignAuthority.Item item : auth.getItems()) {
                String path = item.getPath();
                boolean type = item.getType();
                fileNodes.add(getNodeItem("reportlets/" + path, "reportlets", type, servletName));
                if (type) {
                    getFileNode(fileNodes, root, "reportlets/" + path, servletName);
                }
            }
        }
        return fileNodes;
    }

    private void getFileNode(ArrayList nodeItem, FileNodes root, String path, String servletName) throws JSONException {
        FileNode[] fNodes = root.list(path, false);
        for (int i = 0; i < fNodes.length; i++) {
            FileNode fileNode = fNodes[i];
            String fileNodePath = fileNode.getEnvPath();
            nodeItem.add(getNodeItem(fileNodePath, path, fileNode.isDirectory(), servletName));
            if (fileNode.isDirectory()) {
                getFileNode(nodeItem, root, fileNodePath, servletName);
            }
        }
    }

    private TplInfoBean getNodeItem(String path, String pId, boolean isDirectory, String servletName) {
        boolean isCpt = false;
        String menuId;
        if (path.contains(".cpt")) {
            isCpt = true;
            menuId = path.replace(".cpt", "");
        } else {
            menuId = path.replace(".frm", "");
        }
        if (!isDirectory) {
            menuId = new StringBuffer().append(menuId).append("_f").toString();
        }
        path = path.replace("reportlets/", "");
        String nodeName = menuId.replaceAll(pId + "/", "");

        return new TplInfoBean(menuId, nodeName, isDirectory ? "" : isCpt ? servletName + CPT_PATH + path : servletName + FRM_PATH + path, pId);
    }
}
