package com.fr.plugin.decision.integration.validation;

import com.fr.base.ServerConfig;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Jianye
 * @version 10.0
 * @data 2022/8/24 17:26
 **/
public class DashboardValidate implements Validate {

    public static final DashboardValidate KEY = new DashboardValidate();

    @Override
    public boolean accept(HttpServletRequest request) {
        return getPattern().matcher(request.getRequestURI()).find();
    }

    @Override
    public HashMap<String, Object> getCheckParameter(HttpServletRequest request) {
        HashMap<String, Object> param = new HashMap<>();
        Matcher m = getPattern().matcher(request.getRequestURI());
        m.find();
        param.put("dashboard", m.group());
        return param;
    }

    protected Pattern getPattern() {
        return Pattern.compile("(?<=" + ServerConfig.getInstance().getServletName() + "/v5/design/report/).*?(?=/edit|/view)");
    }
}
