!(function () {
    var params = FR.generateUrlParam(window.location.href);
    var token_key = "fine_auth_token";
    var param_key = "__parameters__";
    var token;

    // url 直接传入
    !token && params.hasOwnProperty(token_key) && (token = params[token_key]);

    // 超级链接到模板
    if (!token) {
        var hp;
        try {
            if (params.hasOwnProperty(param_key) && (hp = JSON.parse(decodeURIComponent(decodeURIComponent(params[param_key])))).hasOwnProperty(token_key)) {
                token = hp[token_key];
            }
        } catch (e) {
            console.error(e);
        }
    }

    if (token) {
        console.log("Load fine_auth_token from parameter successful!");
        var _ajax = FR.ajax;
        FR.ajax = function (i) {
            i.data || ( i.data = {});
            i.data[token_key] = token;
            _ajax.call(this, i);
        };

        var _hyperLinkByGet = FR.doHyperlinkByGet4Reportlet;
        FR.doHyperlinkByGet4Reportlet = function (i) {
            i.para || ( i.para = {});
            i.para[token_key] = token;
            _hyperLinkByGet.call(this, i);
        };

        // 网页框
        let _changeIframe = FR.IframeEditor.prototype._changeIframe;
        FR.IframeEditor.prototype._changeIframe = function (src) {
            src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
            _changeIframe.call(this, src);
        }

        // 网页框插件
        if (FR.RHIframe) {
            let _changeIframe = FR.RHIframe.prototype._changeIframe;
            FR.RHIframe.prototype._changeIframe = function (src) {
                src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
                _changeIframe.call(this, src);
            }
        }

        // 导出请求
        var _openUrlByForm = FR.openUrlByForm;
        FR.openUrlByForm = function (src) {
            src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
            _openUrlByForm.call(this, src);
        }

        // excel导入请求
        var _autoSubmit = FR.autoSubmit;
        FR.autoSubmit = function (options, $form) {
            options.url += (((options.url.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
            _autoSubmit.call(this, options, $form);
        }

        // 打印
        try {
            FR.doPDFPrintForOthers = function (sessionID, printUrl) {
                var finalUrl = printUrl + "?op=fr_print&cmd=no_client&sessionID=" + sessionID + "&fine_auth_token=" + token;
                if (_shouldOpenInNewTab(printUrl)) {
                    window.open(finalUrl, "_blank")
                } else {
                    var $printFrame = $("iframe#printPdf");
                    if ($printFrame.length > 0) {
                        $printFrame.attr("src", finalUrl)
                    } else {
                        $printFrame = $('<iframe id="printPdf" src = "' + finalUrl + '" height="0px" style="border:0"></iframe>');
                        $printFrame.appendTo($("body"))
                    }
                    $printFrame.load(function() {
                        FR.closeSession(sessionID, printUrl);
                        if (_needCallPrintManually()) {
                            $("#printPdf")[0].contentWindow.print()
                        }
                    })
                }
            }

            function _subPrintUrl(printUrl) {
                return printUrl.substring(0, printUrl.indexOf("/", printUrl.indexOf("/") + 2))
            }
            function _isCrossOrigin(printUrl) {
                return printUrl && printUrl.startsWith("http") && !(_subPrintUrl(printUrl) == window.location.origin)
            }
            function _shouldOpenInNewTab(printUrl) {
                if (FR.Browser.isNotNormalBrowser()) {
                    return false
                }
                return FR.Browser.isFirefox() || FR.Browser.isEdge() || ((FR.Browser.isSafari() || FR.Browser.isChrome()) && _isCrossOrigin(printUrl))
            }
            function _needCallPrintManually() {
                if (FR.Browser.isNotNormalBrowser()) {
                    return false
                }
                return FR.Browser.isChrome() || FR.Browser.isSafari()
            }
        } catch (e) {
            console.log(e);
        }

    } else {
        console.log("Load fine_auth_token from parameter failed!");
    }

})();