!(function () {
    var user_only = BI.Constants.getConstant("plugin.integration.userCreate")[0],
        user_roledep = BI.Constants.getConstant("plugin.integration.userCreate")[1];
    var Model = BI.inherit(Fix.Model, {
        state: function () {
            return {
                config: {}
            }
        },

        computed: {
            userType: function () {
                return this.model.config.userStrategy.userType === user_only.userType ? user_only.value : user_roledep.value;
            }
        },

        actions: {
            initData: function (cb) {
                var self = this;
                Dec.Utils.getPluginIntegrateConfig(function (res) {
                    if (!res.errorCode) {
                        self.model.config = res;
                        cb();
                    }
                })
            },

            changeUserType: function (v) {
                this.model.config.userStrategy.userType = (v === user_only.value ? user_only.userType : user_roledep.userType)
            },

            saveData: function (value) {
                Dec.Utils.updatePluginIntegrateConfig(value, function (res) {
                    if (res.data === "success") {
                        BI.Msg.toast("保存成功！", {level: "success"})
                    } else {
                        BI.Msg.toast("保存失败！", {level: "error"})
                    }
                })
            }
        }
    });
    BI.model("dec.plugin.system.integration.model", Model);
})();