!(function () {
    var WIDGET_HEIGHT = 24;
    var user_only = BI.Constants.getConstant("plugin.integration.userCreate")[0],
        user_roledep = BI.Constants.getConstant("plugin.integration.userCreate")[1];
    var dep_legnth = BI.Constants.getConstant("plugin.integration.dep")[0];

    var Pane = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-plugin-system-integration"
        },
        _store: function () {
            return BI.Models.getModel("dec.plugin.system.integration.model");
        },
        beforeInit: function (cb) {
            this.store.initData(cb);
        },
        render: function () {
            var self = this;
            var createUserInfoPane = {
                type: "bi.vertical",
                lgap: 10, bgap: 10,
                ref: function (_ref) {
                    self.createUserInfoPane = _ref;
                },
                invisible: !self.model.config.createUserTurnOn,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: "创建远程连接同名目录",
                        title: "创建远程连接同名目录",
                        width: 210
                    }, {
                        type: "dec.switch_button",
                        value: self.model.config.remoteFolder,
                        ref: function (_ref) {
                            self.remoteFolder = _ref;
                        }
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    height: WIDGET_HEIGHT,
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: "用户创建策略",
                        width: 210
                    }, {
                        type: "dec.plugin.system.integration.group",
                        value: self.model.userType,
                        items: BI.Constants.getConstant("plugin.integration.userCreate"),
                        changeAction: function (e) {
                            self.depStrategyPane.setVisible(e === user_roledep.value);
                            self.store.changeUserType(e);
                        },
                        ref: function (_ref) {
                            self.userCreate = _ref;
                        }
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    height: WIDGET_HEIGHT,
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: "密码策略",
                        width: 210
                    }, {
                        type: "dec.plugin.system.integration.group",
                        value: self.model.config.userStrategy.pwdStrategy,
                        items: BI.Constants.getConstant("plugin.integration.pwd"),
                        ref: function (_ref) {
                            self.pwd = _ref;
                        }
                    }]
                }, {
                    type: "bi.vertical",
                    bgap: 10,
                    invisible: self.model.userType === user_only.value,
                    items: [{
                        type: "bi.vertical_adapt",
                        height: WIDGET_HEIGHT,
                        items: [{
                            type: "bi.label",
                            textAlign: "left",
                            cls: "dec-font-weight-bold",
                            text: "创建部门策略",
                            width: 210
                        }, {
                            type: "dec.plugin.system.integration.group",
                            value: self.model.config.userStrategy.depStrategy || dep_legnth.value,
                            items: BI.Constants.getConstant("plugin.integration.dep"),
                            ref: function (_ref) {
                                self.dep = _ref;
                            },
                            changeAction: function (e) {
                                var depLen = e == 0;
                                self.specialRootId.setVisible(depLen);
                                self.separator.setVisible(!depLen);
                            },
                        }]
                    }, {
                        type: "dec.label.editor.item",
                        textWidth: 210,
                        invisible: BI.isKey(self.model.config.userStrategy.depStrategy) && self.model.config.userStrategy.depStrategy != 0,
                        cls: "dec-font-weight-bold",
                        text: "特殊根部门ID",
                        editorWidth: 180,
                        value: self.model.config.userStrategy.specialRootId,
                        ref: function (_ref) {
                            self.specialRootId = _ref
                        }
                    }, {
                        type: "dec.label.editor.item",
                        textWidth: 210,
                        invisible: self.model.config.userStrategy.depStrategy != 1,
                        cls: "dec-font-weight-bold",
                        text: "分隔符",
                        editorWidth: 180,
                        value: self.model.config.userStrategy.separator,
                        ref: function (_ref) {
                            self.separator = _ref
                        }
                    }],
                    ref: function (_ref) {
                        self.depStrategyPane = _ref;
                    }
                }]
            };


            return {
                type: "bi.vertical",
                cls: "bi-card",
                hgap: 10,
                items: [{
                    type: "dec.card.vertical",
                    text: "配置项",
                    content: {
                        type: "bi.vertical",
                        vgap: 10,
                        items: [{
                            type: "dec.label.editor.item",
                            textWidth: 210,
                            cls: "dec-font-weight-bold",
                            text: "帆软平台地址",
                            title: "帆软平台地址",
                            watermark: "http(s)://ip:port/webroot/decision",
                            editorWidth: 300,
                            value: self.model.config.decisionUrl,
                            ref: function (_ref) {
                                self.decisionUrl = _ref
                            }
                        }, {
                            type: "dec.label.editor.item",
                            textWidth: 210,
                            cls: "dec-font-weight-bold",
                            text: "Jwt 密钥值",
                            editorWidth: 300,
                            value: self.model.config.jwtKey,
                            ref: function (_ref) {
                                self.jwtKey = _ref
                            }
                        }, {
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "认证完成创建用户",
                                title: "Jwt Token认证用户在平台中不存在时，自动在平台中创建用户信息",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.createUserTurnOn,
                                listeners: [{
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.createUserInfoPane.setVisible(this.getValue());
                                    }
                                }],
                                ref: function (_ref) {
                                    self.createUserTurnOn = _ref;
                                }
                            }]
                        }, createUserInfoPane, {
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "模板预览参数校验",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.paraCheckTurnOn,
                                listeners: [{
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.paraCheckPane.setVisible(this.getValue());
                                    }
                                }],
                                ref: function (_ref) {
                                    self.paraCheckTurnOn = _ref;
                                }
                            }]
                        }, {
                            type: "bi.vertical",
                            lgap: 10, bgap: 10,
                            invisible: !self.model.config.paraCheckTurnOn,
                            items: [{
                                type: "dec.label.editor.item",
                                textWidth: 210,
                                cls: "dec-font-weight-bold",
                                text: "校验地址",
                                title: "校验地址",
                                editorWidth: 300,
                                value: self.model.config.paraCheckUrl,
                                ref: function (_ref) {
                                    self.paraCheckUrl = _ref
                                }
                            }],
                            ref: function (_ref) {
                                self.paraCheckPane = _ref
                            }
                        }, {
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "远程设计连接开启token校验",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.remoteTokenAuth,
                                ref: function (_ref) {
                                    self.remoteTokenAuth = _ref;
                                }
                            }]
                        }, {
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "用户信息是否进行AES加密",
                                title: "Jwt Token中的 subject 字段是否使用 AES/ECB/PKCS5Padding 加密",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.aesEncryptSubject,
                                ref: function (_ref) {
                                    self.aesEncryptSubjectButton = _ref;
                                },
                                listeners: [{
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.aesEncryptKeyPane.setVisible(this.getValue());
                                    }
                                }],
                            }]
                        }, {
                            type: "bi.vertical",
                            lgap: 10, bgap: 10,
                            invisible: !self.model.config.aesEncryptSubject,
                            items: [{
                                type: "dec.label.editor.item",
                                textWidth: 210,
                                cls: "dec-font-weight-bold",
                                text: "AES加密密钥(16位)",
                                title: "AES加密密钥",
                                editorWidth: 180,
                                value: self.model.config.aesEncryptKey,
                                ref: function (_ref) {
                                    self.aesEncryptKeyEditor = _ref
                                }
                            }],
                            ref: function (_ref) {
                                self.aesEncryptKeyPane = _ref
                            }
                        }, /*{
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "自定义登录页",
                                title: "页面未登录时跳转至指定URL地址替代帆软登录页",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.portalURLTurnOn,
                                ref: function (_ref) {
                                    self.portalURLTurnOnBtn = _ref;
                                },
                                listeners: [{
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.portalURLPane.setVisible(this.getValue());
                                    }
                                }],
                            }]
                        }, {
                            type: "bi.vertical",
                            lgap: 10, bgap: 10,
                            invisible: !self.model.config.portalURLTurnOn,
                            items: [{
                                type: "dec.label.editor.item",
                                textWidth: 210,
                                cls: "dec-font-weight-bold",
                                text: "地址",
                                title: "自定义登录页地址",
                                editorWidth: 180,
                                value: self.model.config.portalURL,
                                ref: function (_ref) {
                                    self.portalURLEditor = _ref
                                }
                            }],
                            ref: function (_ref) {
                                self.portalURLPane = _ref
                            }
                        }, */{
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "跨域功能",
                                title: "开启后会在 response 中会添加允许的请求头",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.crossDomain,
                                ref: function (_ref) {
                                    self.crossDomainBtn = _ref;
                                }
                            }]
                        }, {
                            type: "bi.vertical_adapt",
                            height: 24,
                            items: [{
                                type: "bi.label",
                                textAlign: "left",
                                cls: "dec-font-weight-bold",
                                text: "移动端忽略过期cookie",
                                title: "移动端忽略过期cookie",
                                width: 210
                            }, {
                                type: "dec.switch_button",
                                value: self.model.config.ignoreMobileCookie,
                                ref: function (_ref) {
                                    self.ignoreMobileCookie = _ref;
                                }
                            }]
                        }]
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function () {
                            self.validate() && self.store.saveData(self.getValue());
                        }
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: "显示唤醒设计器",
                        title: "平台首页地址显示唤醒设计器功能",
                        width: 210
                    }, {
                        type: "dec.switch_button",
                        value: self.model.config.webStartDesigner,
                        ref: function (_ref) {
                            self.webStartDesigner = _ref;
                        },
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function () {
                                self.downloadURLPane.setVisible(this.getValue());
                            }
                        }],
                    }]
                }, {
                    type: "bi.vertical",
                    lgap: 10, vgap: 10,
                    invisible: !self.model.config.webStartDesigner,
                    items: [{
                        type: "dec.label.editor.item",
                        textWidth: 210,
                        cls: "dec-font-weight-bold",
                        text: "64位设计器下载地址",
                        title: "64位设计器下载地址",
                        editorWidth: 500,
                        value: self.model.config.downloadUrl64,
                        ref: function (_ref) {
                            self.downloadUrl64 = _ref
                        }
                    }, {
                        type: "dec.label.editor.item",
                        textWidth: 210,
                        cls: "dec-font-weight-bold",
                        text: "32位设计器下载地址",
                        title: "32位设计器下载地址",
                        editorWidth: 500,
                        value: self.model.config.downloadUrl32,
                        ref: function (_ref) {
                            self.downloadUrl32 = _ref
                        }
                    }],
                    ref: function (_ref) {
                        self.downloadURLPane = _ref
                    }
                }]

            }
        },

        aesValidate: function () {
            var editor = this.aesEncryptKeyEditor;
            return editor.getValue().length == 16 ? true : (editor.showError("AES密钥长度需为16"), false);
        },

        validate: function () {
            if (!BI.isKey(this.decisionUrl.getValue())) {
                BI.Msg.toast("帆软平台地址不允许为空", {level: "error"});
                return false;
            }
            if (this.aesEncryptSubjectButton.getValue()) {
                return this.aesValidate();
            }
            if (this.webStartDesigner.getValue()) {
                if (!BI.isKey(this.downloadUrl32.getValue())) {
                    BI.Msg.toast("32位下载地址不允许为空", {level: "error"});
                    return false;
                }
                if (!BI.isKey(this.downloadUrl64.getValue())) {
                    BI.Msg.toast("64位下载地址不允许为空", {level: "error"});
                    return false;
                }
            }
            return true;
        },

        getValue: function () {
            var self = this;
            var value = {
                decisionUrl: self.decisionUrl.getValue(),
                jwtKey: self.jwtKey.getValue(),
                remoteTokenAuth: self.remoteTokenAuth.getValue(),
                aesEncryptSubject: self.aesEncryptSubjectButton.getValue(),
                aesEncryptKey: self.aesEncryptKeyEditor.getValue(),
                /*portalURLTurnOn: self.portalURLTurnOnBtn.getValue(),
                portalURL: self.portalURLEditor.getValue(),*/
                crossDomain: self.crossDomainBtn.getValue(),
                remoteFolder: self.remoteFolder.getValue(),
                ignoreMobileCookie: self.ignoreMobileCookie.getValue()
            };

            if (self.createUserTurnOn.getValue()) {
                var userStrategy = {
                    pwdStrategy: self.pwd.getValue()
                };
                switch (self.userCreate.getValue()) {
                    case user_only.value:
                        BI.extend(userStrategy, {
                            userType: user_only.userType
                        });
                        break;
                    case user_roledep.value:
                        BI.extend(userStrategy, {
                            userType: user_roledep.userType,
                            depStrategy: self.dep.getValue(),
                            specialRootId: self.specialRootId.getValue(),
                            separator: self.separator.getValue()
                        });
                        break;
                }
                BI.extend(value, {
                    createUserTurnOn: true,
                    userStrategy: userStrategy
                });
            } else {
                BI.extend(value, {
                    createUserTurnOn: false
                })
            }

            if (self.paraCheckTurnOn.getValue()) {
                BI.extend(value, {
                    paraCheckTurnOn: true,
                    paraCheckUrl: self.paraCheckUrl.getValue()
                })
            } else {
                BI.extend(value, {
                    paraCheckTurnOn: false
                })
            }

            var webStartDesigner = self.webStartDesigner.getValue();
            value.webStartDesigner = webStartDesigner;
            if (webStartDesigner) {
                BI.extend(value, {
                    downloadUrl64: self.downloadUrl64.getValue(),
                    downloadUrl32: self.downloadUrl32.getValue(),
                })
            }
            console.log(value);
            return value;
        }
    });

    BI.shortcut("dec.plugin.system.integration", Pane);
})();